Package com.google.gwt.event.shared

## Class EventBus

- java.lang.Object
- - com.google.web.bindery.event.shared.EventBus
  - - com.google.gwt.event.shared.EventBus

- All Implemented Interfaces:
    `HasHandlers`
  Direct Known Subclasses:
    `CountingEventBus`, `ResettableEventBus`, `SimpleEventBus`

      public abstract class EventBus
      extends EventBus
      implements HasHandlers

  Extends {com.google.web.bindery.event.shared.EventBus} for legacy compatibility.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EventBus()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract <H extends EventHandler> HandlerRegistration` | `addHandler​(GwtEvent.Type<H> type, H handler)` |
    `<H> HandlerRegistration` | `addHandler​(Event.Type<H> type, H handler)` | Adds an unfiltered handler to receive events of this type from all sources.
    `abstract <H extends EventHandler> HandlerRegistration` | `addHandlerToSource​(GwtEvent.Type<H> type, java.lang.Object source, H handler)` |
    `<H> HandlerRegistration` | `addHandlerToSource​(Event.Type<H> type, java.lang.Object source, H handler)` | Adds a handler to receive events of this type from the given source.
    `protected void` | `castFireEvent​(GwtEvent<?> event)` |
    `protected void` | `castFireEventFromSource​(GwtEvent<?> event, java.lang.Object source)` |
    `abstract void` | `fireEvent​(GwtEvent<?> event)` | Fires the given event to the handlers listening to the event's type.
    `void` | `fireEvent​(Event<?> event)` | Fires the event from no source.
    `abstract void` | `fireEventFromSource​(GwtEvent<?> event, java.lang.Object source)` |
    `void` | `fireEventFromSource​(Event<?> event, java.lang.Object source)` | Fires the given event to the handlers listening to the event's type.
    `protected HandlerRegistration` | `wrap​(HandlerRegistration reg)` |

    - ### Methods inherited from class com.google.web.bindery.event.shared.EventBus

      `dispatchEvent, setSourceOfEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EventBus

          public EventBus()

  - ### Method Detail

    - #### addHandler

          public <H> HandlerRegistration addHandler​(Event.Type<H> type,
                                                    H handler)

      Description copied from class: `EventBus`
      Adds an unfiltered handler to receive events of this type from all sources.

      It is rare to call this method directly. More typically an `Event` subclass will provide a static `register` method, or a widget will accept handlers directly.

      Specified by:
        `addHandler` in class `EventBus`
      Type Parameters:
        `H` - The type of handler
      Parameters:
        `type` - the event type associated with this handler
        `handler` - the handler
      Returns:
        the handler registration, can be stored in order to remove the handler later

    - #### addHandler

          public abstract <H extends EventHandler> HandlerRegistration addHandler​(GwtEvent.Type<H> type,
                                                                                  H handler)

    - #### addHandlerToSource

          public <H> HandlerRegistration addHandlerToSource​(Event.Type<H> type,
                                                            java.lang.Object source,
                                                            H handler)

      Description copied from class: `EventBus`
      Adds a handler to receive events of this type from the given source.

      It is rare to call this method directly. More typically a `Event` subclass will provide a static `register` method, or a widget will accept handlers directly.

      Specified by:
        `addHandlerToSource` in class `EventBus`
      Type Parameters:
        `H` - The type of handler
      Parameters:
        `type` - the event type associated with this handler
        `source` - the source associated with this handler
        `handler` - the handler
      Returns:
        the handler registration, can be stored in order to remove the handler later

    - #### addHandlerToSource

          public abstract <H extends EventHandler> HandlerRegistration addHandlerToSource​(GwtEvent.Type<H> type,
                                                                                          java.lang.Object source,
                                                                                          H handler)

    - #### fireEvent

          public void fireEvent​(Event<?> event)

      Description copied from class: `EventBus`
      Fires the event from no source. Only unfiltered handlers will receive it.

      Any exceptions thrown by handlers will be bundled into a `UmbrellaException` and then re-thrown after all handlers have completed. An exception thrown by a handler will not prevent other handlers from executing.

      Specified by:
        `fireEvent` in class `EventBus`
      Parameters:
        `event` - the event to fire

    - #### fireEvent

          public abstract void fireEvent​(GwtEvent<?> event)

      Description copied from interface: `HasHandlers`
      Fires the given event to the handlers listening to the event's type.

      Any exceptions thrown by handlers will be bundled into a `UmbrellaException` and then re-thrown after all handlers have completed. An exception thrown by a handler will not prevent other handlers from executing.

      Specified by:
        `fireEvent` in interface `HasHandlers`
      Parameters:
        `event` - the event

    - #### fireEventFromSource

          public void fireEventFromSource​(Event<?> event,
                                          java.lang.Object source)

      Description copied from class: `EventBus`
      Fires the given event to the handlers listening to the event's type.

      Any exceptions thrown by handlers will be bundled into a `UmbrellaException` and then re-thrown after all handlers have completed. An exception thrown by a handler will not prevent other handlers from executing.

      Specified by:
        `fireEventFromSource` in class `EventBus`
      Parameters:
        `event` - the event to fire

    - #### fireEventFromSource

          public abstract void fireEventFromSource​(GwtEvent<?> event,
                                                   java.lang.Object source)

    - #### castFireEvent

          protected void castFireEvent​(GwtEvent<?> event)

    - #### castFireEventFromSource

          protected void castFireEventFromSource​(GwtEvent<?> event,
                                                 java.lang.Object source)

    - #### wrap

          protected HandlerRegistration wrap​(HandlerRegistration reg)